# MySQL-Front Dump 2.2
#
# Host: 192.168.72.193   Database: ciscoweb
#--------------------------------------------------------
# Server version 4.1.10a


#
# Table structure for table 'conferences'
#

CREATE TABLE `conferences` (
  `confname` varchar(30) NOT NULL default 'Not named',
  `owner` varchar(30) NOT NULL default '',
  `mcaddress` varchar(18) NOT NULL default '0',
  `closedlist` text,
  `listenonly` tinyint(1) unsigned default '0',
  `talker` varchar(30) default NULL,
  `expires` varchar(25) default NULL,
  `pin` varchar(10) default NULL,
  UNIQUE KEY `mcaddress` (`mcaddress`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



#
# Table structure for table 'contacts'
#

CREATE TABLE `contacts` (
  `id` varchar(36) NOT NULL default '0',
  `display_name` varchar(100) NOT NULL default '',
  `member_of` varchar(100) NOT NULL default '',
  `lname` varchar(100) NOT NULL default '',
  `fname` varchar(100) NOT NULL default '',
  `company` varchar(100) NOT NULL default '',
  `title` varchar(100) NOT NULL default '',
  `office_phone` varchar(100) default '',
  `home_phone` varchar(100) default '',
  `cell_phone` varchar(100) default '',
  `date` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `owner` varchar(100) NOT NULL default '',
  `custom_phone` varchar(100) default '',
  `custom_number` varchar(100) default '',
  `sup_prefix_office` tinyint(4) default '0',
  `sup_prefix_home` tinyint(4) default '0',
  `sup_prefix_cell` tinyint(4) default '0',
  `sup_prefix_other` tinyint(4) default '0',
  `sup_prefix_custom` tinyint(4) default '0',
  `other_phone` varchar(100) default ''
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



#
# Table structure for table 'global_pref'
#

CREATE TABLE `global_pref` (
  `preference` varchar(11) NOT NULL default '',
  `ph_sec` char(3) NOT NULL default '',
  `prefix` varchar(100) NOT NULL default '',
  `ph_prfx` varchar(100) NOT NULL default '',
  `memo_ob` varchar(20) NOT NULL default '',
  `ob_sec` char(3) NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



#
# Table structure for table 'memos'
#

CREATE TABLE `memos` (
  `id` varchar(100) NOT NULL default '',
  `msg` blob NOT NULL,
  `date` int(11) NOT NULL default '0',
  `access` varchar(100) NOT NULL default '',
  `sender` varchar(100) NOT NULL default '',
  `receiver` varchar(100) NOT NULL default '',
  `title` varchar(100) NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



#
# Table structure for table 'multicasts'
#

CREATE TABLE `multicasts` (
  `id` int(8) unsigned NOT NULL auto_increment,
  `ip` varchar(18) NOT NULL default '',
  UNIQUE KEY `id` (`id`,`ip`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



#
# Table structure for table 'object'
#

CREATE TABLE `object` (
  `id` varchar(36) NOT NULL default '0',
  `type` varchar(100) NOT NULL default '',
  `member_of` varchar(100) default '',
  `title` varchar(100) NOT NULL default '',
  `href` varchar(255) default '',
  `style` varchar(100) default '',
  `access` varchar(100) default ''
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



#
# Table structure for table 'phone'
#

CREATE TABLE `phone` (
  `id` varchar(36) NOT NULL default '0',
  `MAC` varchar(100) NOT NULL default '',
  `date` varchar(100) NOT NULL default '',
  `number` varchar(100) NOT NULL default '',
  `away_msg` varchar(100) NOT NULL default '',
  `fname` varchar(100) NOT NULL default '',
  `lname` varchar(100) NOT NULL default '',
  `status` int(1) NOT NULL default '0',
  `access_lvl` varchar(100) default '',
  `idlelogo` varchar(25) default 'logo',
  `ipaddress` varchar(52) NOT NULL default '0.0.0.0',
  `pushuserid` varchar(13) NOT NULL default '',
  `pushpass` varchar(13) NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



#
# Table structure for table 'phonehelp'
#

CREATE TABLE `phonehelp` (
  `language` varchar(4) default NULL,
  `numbers` text,
  `volume` text,
  `headset` text,
  `speaker` text,
  `microphone` text,
  `help` text,
  `voicemail` text,
  `directory` text,
  `services` text,
  `config` text,
  `scroll` text,
  `line` text
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



#
# Table structure for table 'sccp_pref'
#

CREATE TABLE `sccp_pref` (
  `preference` varchar(25) default 'primary',
  `server1` varchar(60) default NULL,
  `server2` varchar(60) default NULL,
  `server3` varchar(60) default NULL,
  `server4` varchar(60) default NULL,
  `server5` varchar(60) default NULL,
  `server1port` varchar(8) default '2000',
  `server2port` varchar(8) default '2000',
  `server3port` varchar(8) default '2000',
  `server4port` varchar(8) default '2000',
  `server5port` varchar(8) default '2000',
  `idletimeout` varchar(8) default '1800',
  `authenticationurl` varchar(128) default NULL,
  `directoryurl` varchar(128) default NULL,
  `idleurl` varchar(128) default NULL,
  `informationurl` varchar(128) default NULL,
  `messagesurl` varchar(128) default NULL,
  `proxyserversurl` varchar(128) default NULL,
  `servicesurl` varchar(128) default NULL,
  `networklocale` varchar(128) default NULL,
  `langcode` varchar(5) default NULL,
  `localename` varchar(128) default NULL,
  `tftproot` varchar(128) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



#
# Table structure for table 'users'
#

CREATE TABLE `users` (
  `id` varchar(36) NOT NULL default '',
  `username` varchar(100) NOT NULL default '',
  `password` varchar(100) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `account_type` varchar(100) NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=latin1;


LOCK TABLES `users` WRITE;
INSERT INTO `users` VALUES ('0','admin','a74ad8dfacd4f985eb3977517615ce25','','Admin'),('639e8ade-13225-cad00-ddeb-43b55e6719','joe','8ff32489f92f33416694be8fdc2d4c22','joe1234@hostXYZ.com','User');
UNLOCK TABLES;

LOCK TABLES `sccp_pref` WRITE;
INSERT INTO `sccp_pref` preference VALUES ('primary');
UNLOCK TABLES;

